package tools.descartes.dql.connector.kieker.structures.records;

import tools.descartes.dql.connector.kieker.structures.identifier.AbstractIdentifier;

public abstract class AbstractRecord<T extends AbstractIdentifier> {
	private T identifier; //Anpassen an AbstactIdentifier
	private long timestamp;

	public long getTimestamp() {
		return timestamp;
	}

	public void setTimestamp(final long timestamp) {
		this.timestamp = timestamp;
	}

	public T getIdentifier() {
		return identifier;
	}

	
	protected void setIdentifier(final T identifier) {
		this.identifier = identifier;
	}
	
	public String toString(){
		return identifier.toString() + "\n\t\t TIME " + timestamp; 
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((identifier == null) ? 0 : identifier.hashCode());
		result = prime * result + (int) (timestamp ^ (timestamp >>> 32));
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		AbstractRecord<?> other = (AbstractRecord<?>) obj;
		if (identifier == null) {
			if (other.identifier != null)
				return false;
		} else if (!identifier.equals(other.identifier))
			return false;
		if (timestamp != other.timestamp)
			return false;
		return true;
	};

}
